nightly.sh revision 23259b79afff8cc5e183c5be57e05120f378fa72
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright 2007 Sun Microsystems, Inc. All rights reserved.
# Use is subject to license terms.
#
# ident "%Z%%M% %I% %E% SMI"
#
# Based on the nightly script from the integration folks,
# Mostly modified and owned by mike_s.
# Changes also by kjc, dmk.
#
# BRINGOVER_WS may be specified in the env file.
# The default is the old behavior of CLONE_WS
#
# -i on the command line, means fast options, so when it's on the
# command line (only), lint and check builds are skipped no matter what
# the setting of their individual flags are in NIGHTLY_OPTIONS.
#
# LINTDIRS can be set in the env file, format is a list of:
#
# /dirname-to-run-lint-on flag
#
# Where flag is: y - enable lint noise diff output
# n - disable lint noise diff output
#
#
# -A flag in NIGHTLY_OPTIONS checks ABI diffs in .so files
# This option requires a couple of scripts.
#
# OPTHOME and TEAMWARE may be set in the environment to override /opt
#
#
# The CDPATH variable causes ksh's `cd' builtin to emit messages to stdout
# under certain circumstances, which can really screw things up; unset it.
#
unset CDPATH
# function to do a DEBUG and non-DEBUG build. Needed because we might
# need to do another for the source build, and since we only deliver DEBUG or
# non-DEBUG packages.
# timestamp the start of a nightly build; the findunref tool uses it.
# non-DEBUG build begins
export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
export RELEASE_BUILD ; RELEASE_BUILD=
unset EXTRA_OPTIONS
unset EXTRA_CFLAGS
fi
else
fi
# non-DEBUG build ends
# DEBUG build begins
export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
unset RELEASE_BUILD
unset EXTRA_OPTIONS
unset EXTRA_CFLAGS
fi
else
fi
# DEBUG build ends
}
#
# usage: filelist DESTDIR PATTERN
#
DEST=$1
PATTERN=$2
cd ${DEST}
if [ ! -f ${OBJFILES} ]; then
return;
fi
do
# wildcard expansion
for j in $i
do
if [ -f "$j" ]; then
echo $j
fi
if [ -d "$j" ]; then
echo $j
fi
done
}
# function to save off binaries after a full build for later
# restoration
# save off list of binaries
tee -a $mail_msg_file >> $LOGFILE
rm -f ${BINARCHIVE}
cd ${CODEMGR_WS}
> ${BINARCHIVE}
}
# delete files
# usage: hybridize_files DESTDIR MAKE_TARGET
DEST=$1
MAKETARG=$2
tee -a $mail_msg_file >> $LOGFILE
do
done
do
rm -f ${i}+
< ${i} > ${i}+
mv ${i}+ ${i}
done
}
# restore binaries into the proper source tree.
# usage: restore_binaries DESTDIR MAKE_TARGET
DEST=$1
MAKETARG=$2
tee -a $mail_msg_file >> $LOGFILE
cd ${DEST}
zcat ${BINARCHIVE} | \
}
# rename files we save binaries of
# usage: rename_files DESTDIR MAKE_TARGET
DEST=$1
MAKETARG=$2
tee -a $mail_msg_file >> $LOGFILE
do
echo ${i} | tee -a $mail_msg_file >> ${LOGFILE}
rm -f ${i}.export
mv ${i} ${i}.export
done
}
#
# Copy some or all of the source tree.
# usage: copy_source CODEMGR_WS DESTDIR LABEL SRCROOT
#
WS=$1
DEST=$2
label=$3
srcroot=$4
tee -a $mail_msg_file >> $LOGFILE
cd ${WS}
}
#
# usage: set_up_source_build CODEMGR_WS DESTDIR MAKE_TARGET
# Sets SRC to the modified source tree, for use by the caller when it
# builds the tree.
#
WS=$1
DEST=$2
MAKETARG=$3
cd $SRC
cd ${DEST}
if [ "${MAKETARG}" = "CRYPT_SRC" ]; then
rm -f ${CODEMGR_WS}/crypt_files.cpio.Z
tee -a $mail_msg_file >> $LOGFILE
for i in `cat ${CRYPT_FILES}`
do
# make sure the files exist
if [ -f "$i" ]; then
continue
fi
if [ -d "$i" ]; then
continue
fi
done
fi
if [ "${MAKETARG}" = "EXPORT_SRC" ]; then
# rename first, since we might restore a file
# of the same name (mapfiles)
fi
fi
# save the cleartext
tee -a $mail_msg_file >> $LOGFILE
cd ${DEST}
compress > ${CODEMGR_WS}/${MAKETARG}.cpio.Z
if [ "${MAKETARG}" = "EXPORT_SRC" ]; then
fi
if [ "${MAKETARG}" = "CRYPT_SRC" ]; then
fi
}
# function to do the build.
# usage: build LABEL SUFFIX
LABEL=$1
SUFFIX=$2
CPIODIR=${CPIODIR_ORIG}${SUFFIX}
fi
#
# Build OS-Networking source
#
>> $LOGFILE
cd $SRC
if [ "$?" = "0" ]; then
build_ok=n
fi
if [ "$?" = "0" ]; then
build_ok=n
fi
fi
>> $LOGFILE
tail -3 $SRC/${INSTALLOG}.out >>$mail_msg_file
fi
fi
fi
#
# Re-sign selected binaries using signing server
# (gatekeeper builds only)
#
signing_file="${TMPDIR}/signing"
rm -f ${signing_file}
export CODESIGN_USER
tee -a ${signing_file} >> $LOGFILE
>> $LOGFILE
fi
#
# Create cpio archives for preintegration testing (PIT)
#
>> $LOGFILE
makebfu_file="${TMPDIR}/makebfu"
rm -f ${makebfu_file}
makebfu 2>&1 | \
tee -a ${makebfu_file} >> $LOGFILE
sort | uniq >> $mail_msg_file
rm -f ${makebfu_file}
# hack for test folks
else
X=${CPIODIR}
fi
else
>> $LOGFILE
fi
#
# Building Packages
#
>> $LOGFILE
mkdir -p $PKGARCHIVE
#
# Optional build of sparc realmode on i386
#
echo "Clearing out ${SPARC_RM_PKGARCHIVE} ..." \
>> $LOGFILE
rm -rf ${SPARC_RM_PKGARCHIVE}
mkdir -p ${SPARC_RM_PKGARCHIVE}
fi
else
fi
}
# Usage: dolint /dir y|n
if [ ! -d "$1" ]; then
echo "dolint error: $1 is not a directory"
exit 1
fi
if [ "$2" != "y" -a "$2" != "n" ]; then
echo "dolint internal error: $2 should be 'y' or 'n'"
exit 1
fi
lintdir=$1
dodiff=$2
export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
unset RELEASE_BUILD
unset EXTRA_OPTIONS
unset EXTRA_CFLAGS
#
# '$MAKE lint' in $lintdir
#
# remove old lint.out
if [ -f $lintdir/lint-noise.ref ]; then
fi
cd $lintdir
#
# Remove all .ln files to ensure a full reference file
#
rm -f Nothing_to_remove \
tail -3 $LINTOUT >>$mail_msg_file
fi
fi
# should be none, though there are a few that were filtered out
# above
| sort | uniq >> $mail_msg_file
fi
}
# Install proto area from IHV build
echo "\n==== Installing IHV proto area ====\n" \
>> $LOGFILE
fi
else
fi
}
# Install IHV packages in PKGARCHIVE
# usage: copy_ihv_pkgs LABEL SUFFIX
LABEL=$1
SUFFIX=$2
# always use non-DEBUG IHV packages
>> $LOGFILE
else
fi
>> $LOGFILE
else
fi
}
# usage: build_tools DESTROOT
DESTROOT=$1
>> $LOGFILE
cd ${TOOLS}
egrep -v warning >> $mail_msg_file
if [ "$?" != "0" ]; then
export STABS
export CTFSTABS
export GENOFFSETS
CTFCONVERT=${DESTROOT}/opt/onbld/bin/${MACH}/ctfconvert
export CTFCONVERT
export CTFMERGE
export CTFCVTPTBL
export CTFFINDMOD
else
fi
export ELFSIGN
export PATH
fi
}
"$@"
else
arg="\"$1\""
shift
for i
do
done
fi
}
#
# Verify that the closed tree is present if it needs to be.
# Sets CLOSED_IS_PRESENT for future use.
#
CLOSED_IS_PRESENT="yes"
else
CLOSED_IS_PRESENT="no"
fi
export CLOSED_IS_PRESENT
fi
#
# If it's an old (pre-split) tree or an empty
# workspace, don't complain.
#
if grep -s CLOSED_BUILD $SRC/Makefile.master > /dev/null; then
echo "If the closed sources are not present," \
"ON_CLOSED_BINS"
echo "must point to the closed binaries tree."
exit 1
fi
fi
}
echo "WARNING: Obsolete $1 build requested; request will be ignored"
}
if [ "$OPTHOME" = "" ]; then
export OPTHOME
fi
if [ "$TEAMWARE" = "" ]; then
export TEAMWARE
fi
USAGE='Usage: nightly [-in] [-V VERS ] [ -S E|D|H|O ] <env_file>
Where:
-i Fast incremental options (no clobber, lint, check)
-n Do not do a bringover
-V VERS set the build version string to VERS
-S Build a variant of the source product
E - build exportable source
D - build domestic source (exportable + crypt)
H - build hybrid source (binaries + deleted source)
O - build (only) open source
<env_file> file in Bourne shell syntax that sets and exports
variables that configure the operation of this script and many of
the scripts this one calls. If <env_file> does not exist,
non-DEBUG is the default build type. Build options can be set in the
NIGHTLY_OPTIONS variable in the <env_file> as follows:
-A check for ABI differences in .so files
-D do a build with DEBUG on
-F do _not_ do a non-DEBUG build
-G gate keeper default group of options (-au)
-I integration engineer default group of options (-ampu)
-M do not run pmodes (safe file permission checker)
-N do not run protocmp
-R default group of options for building a release (-mp)
-U update proto area in the parent
-V VERS set the build version string to VERS
-X copy x86 IHV proto area
-a create cpio archives
-f find unreferenced files
-i do an incremental build (no "make clobber")
-l do "make lint" in $LINTDIRS (default: $SRC y)
-m send mail to $MAILTO at end of build
-n do not do a bringover
-p create packages
-r check ELF runtime attributes in the proto area
-u update proto_list_$MACH and friends in the parent workspace;
when used with -f, also build an unrefmaster.out in the parent
-w report on differences between previous and current proto areas
-z compress cpio archives with gzip
-W Do not report warnings (freeware gate ONLY)
-S Build a variant of the source product
E - build exportable source
D - build domestic source (exportable + crypt)
H - build hybrid source (binaries + deleted source)
O - build (only) open source
'
#
# -x less public handling of xmod source for the source product
#
# A log file will be generated under the name $LOGFILE
# for partially completed build and log.`date '+%F'`
# in the same directory for fully completed builds.
#
# default values for low-level FLAGS; G I R are group FLAGS
A_FLAG=n
a_FLAG=n
C_FLAG=n
D_FLAG=n
F_FLAG=n
f_FLAG=n
i_FLAG=n; i_CMD_LINE_FLAG=n
l_FLAG=n
M_FLAG=n
m_FLAG=n
N_FLAG=n
n_FLAG=n
o_FLAG=n
P_FLAG=n
p_FLAG=n
r_FLAG=n
T_FLAG=n
t_FLAG=n
U_FLAG=n
u_FLAG=n
V_FLAG=n
W_FLAG=n
w_FLAG=n
X_FLAG=n
z_FLAG=n
SD_FLAG=n
SE_FLAG=n
SH_FLAG=n
SO_FLAG=n
#
#
build_ok=y
return $?
}
#
# examine arguments
#
#
# single function for setting -S flag and doing error checking.
# usage: set_S_flag <type>
# where <type> is the source build type ("E", "D", ...).
#
if is_source_build; then
echo "Can only build one source variant at a time."
exit 1
fi
if [ "$1" = "E" ]; then
SE_FLAG=y
elif [ "$1" = "D" ]; then
SD_FLAG=y
elif [ "$1" = "H" ]; then
SH_FLAG=y
elif [ "$1" = "O" ]; then
SO_FLAG=y
else
echo "$USAGE"
exit 1
fi
}
OPTIND=1
do
i ) i_FLAG=y; i_CMD_LINE_FLAG=y
;;
n ) n_FLAG=y
;;
S )
;;
t ) t_FLAG=y
;;
V ) V_FLAG=y
;;
\? ) echo "$USAGE"
exit 1
;;
esac
done
# correct argument count after options
# test that the path to the environment-setting file was given
if [ $# -ne 1 ]; then
echo "$USAGE"
exit 1
fi
# check if user is running nightly as root
# ISUSER is set non-zero if an ordinary user runs nightly, or is zero
# when root invokes nightly.
#
# force locale to C
LC_COLLATE=C; export LC_COLLATE
LC_MESSAGES=C; export LC_MESSAGES
LC_MONETARY=C; export LC_MONETARY
LC_NUMERIC=C; export LC_NUMERIC
# clear environment variables we know to be bad for the build
unset LD_OPTIONS
unset CONFIG
unset GROUP
unset OWNER
unset REMOTE
unset ENV
unset ARCH
unset CLASSPATH
unset NAME
#
# Setup environmental variables
#
if [ -f $1 ]; then
if [[ $1 = */* ]]; then
. $1
else
. ./$1
fi
else
else
exit 1
fi
fi
# contents of stdenv.sh inserted after next line:
# STDENV_START
# STDENV_END
#
# place ourselves in a new task, respecting BUILD_PROJECT if set.
#
if [ -z "$BUILD_PROJECT" ]; then
else
fi
#
# See if NIGHTLY_OPTIONS is set
#
if [ "$NIGHTLY_OPTIONS" = "" ]; then
NIGHTLY_OPTIONS="-aBm"
fi
#
# If BRINGOVER_WS was not specified, let it default to CLONE_WS
#
if [ "$BRINGOVER_WS" = "" ]; then
fi
#
# If BRINGOVER_FILES was not specified, default to usr
#
if [ "$BRINGOVER_FILES" = "" ]; then
BRINGOVER_FILES="usr"
fi
#
# If the closed sources are not present, the closed binaries must be
# present for the build to succeed. If there's no pointer to the
# closed binaries, flag that now, rather than forcing the user to wait
# a couple hours (or more) to find out.
#
#
# Note: changes to the option letters here should also be applied to the
# bldenv script. `d' is listed for backward compatibility.
#
OPTIND=1
do
A ) A_FLAG=y
;;
a ) a_FLAG=y
;;
B ) D_FLAG=y
;; # old version of D
C ) C_FLAG=y
;;
D ) D_FLAG=y
;;
F ) F_FLAG=y
;;
f ) f_FLAG=y
;;
G ) a_FLAG=y
u_FLAG=y
;;
I ) a_FLAG=y
m_FLAG=y
p_FLAG=y
u_FLAG=y
;;
i ) i_FLAG=y
;;
l ) l_FLAG=y
;;
M ) M_FLAG=y
;;
m ) m_FLAG=y
;;
N ) N_FLAG=y
;;
n ) n_FLAG=y
;;
o ) o_FLAG=y
;;
P ) P_FLAG=y
;; # obsolete
p ) p_FLAG=y
;;
R ) m_FLAG=y
p_FLAG=y
;;
r ) r_FLAG=y
;;
S )
;;
T ) T_FLAG=y
;; # obsolete
t ) t_FLAG=y
;;
U )
if [ -z "${PARENT_ROOT}" ]; then
echo "PARENT_ROOT must be set if the U flag is" \
"present in NIGHTLY_OPTIONS."
exit 1
fi
U_FLAG=y
;;
u ) u_FLAG=y
;;
W ) W_FLAG=y
;;
w ) w_FLAG=y
;;
X ) # now that we no longer need realmode builds, just
# copy IHV packages. only meaningful on x86.
if [ "$MACH" = "i386" ]; then
X_FLAG=y
fi
;;
x ) XMOD_OPT="-x"
;;
z ) z_FLAG=y
;;
\? ) echo "$USAGE"
exit 1
;;
esac
done
if [ "$o_FLAG" = "y" ]; then
echo "Old-style build requires root permission."
exit 1
fi
# Set default value for STAFFER, if needed.
export STAFFER
fi
fi
export MAILTO
fi
export PATH
# roots of source trees, both relative to $SRC and absolute.
relsrcdirs="."
relsrcdirs="$relsrcdirs ../closed"
fi
abssrcdirs=""
for d in $relsrcdirs; do
abssrcdirs="$abssrcdirs $SRC/$d"
done
unset CH
if [ "$o_FLAG" = "y" ]; then
# root invoked old-style build -- make sure it works as it always has
# by exporting 'CH'. The current Makefile.master doesn't use this, but
# the old ones still do.
CH=
export CH
else
PROTOCMPTERSE="protocmp.terse -gu"
fi
POUND_SIGN="#"
# we export POUND_SIGN to speed up the build process -- prevents evaluation of
# the Makefile.master definitions.
maketype="distributed"
# get the dmake version string alone
DMAKE_VERSION=$( $MAKE -v )
# focus in on just the dotted version number alone
DMAKE_MAJOR=$( echo $DMAKE_VERSION | \
# extract the second (or final) integer
DMAKE_MINOR=${DMAKE_MINOR%%.*}
# extract the first integer
DMAKE_MAJOR=${DMAKE_MAJOR%%.*}
CHECK_DMAKE=${CHECK_DMAKE:-y}
# x86 was built on the 12th, sparc on the 13th.
if [ "$CHECK_DMAKE" = "y" -a \
"$DMAKE_VERSION" != "Sun Distributed Make 7.3 2003/03/12" -a \
"$DMAKE_VERSION" != "Sun Distributed Make 7.3 2003/03/13" -a \( \
if [ -z "$DMAKE_VERSION" ]; then
echo "$MAKE is missing."
exit 1
fi
echo `whence $MAKE`" version is:"
echo " ${DMAKE_VERSION}"
cat <<EOF
This version may not be safe for use. Either set TEAMWARE to a better
path or (if you really want to use this version of dmake anyway), add
the following to your environment to disable this check:
CHECK_DMAKE=n
EOF
exit 1
fi
export PATH
export MAKE
if [ "${SUNWSPRO}" != "" ]; then
export PATH
fi
if [ ! -f $HOME/.make.machines ]; then
else
if [ "$DMAKE_MAX_JOBS" = "" ]; then
fi
fi
export DMAKE_MODE
export DMAKE_MAX_JOBS
if [ -z "${ROOT}" ]; then
echo "ROOT must be set."
exit 1
fi
#
# if -V flag was given, reset VERSION to V_ARG
#
if [ "$V_FLAG" = "y" ]; then
fi
#
# Check for IHV root for copying ihv proto area
#
if [ "$X_FLAG" = "y" ]; then
if [ "$IA32_IHV_ROOT" = "" ]; then
echo "IA32_IHV_ROOT: must be set for copying ihv proto"
args_ok=n
fi
if [ ! -d "$IA32_IHV_ROOT" ]; then
echo "$IA32_IHV_ROOT: not found"
args_ok=n
fi
if [ "$IA32_IHV_WS" = "" ]; then
echo "IA32_IHV_WS: must be set for copying ihv proto"
args_ok=n
fi
if [ ! -d "$IA32_IHV_WS" ]; then
echo "$IA32_IHV_WS: not found"
args_ok=n
fi
fi
# Append source version
if [ "$SE_FLAG" = "y" ]; then
VERSION="${VERSION}:EXPORT"
fi
if [ "$SD_FLAG" = "y" ]; then
VERSION="${VERSION}:DOMESTIC"
fi
if [ "$SH_FLAG" = "y" ]; then
VERSION="${VERSION}:MODIFIED_SOURCE_PRODUCT"
fi
if [ "$SO_FLAG" = "y" ]; then
VERSION="${VERSION}:OPEN_ONLY"
fi
TMPDIR="/tmp/nightly.tmpdir.$$"
export TMPDIR
#
# Keep elfsign's use of pkcs11_softtoken from looking in the user home
# directory, which doesn't always work. Needed until all build machines
# have the fix for 6271754
#
export SOFTTOKEN_DIR
# create directories that are automatically removed if the nightly script
# fails to start correctly
dir=$1
while [ ! -d $dir ]; do
done
torm=
else
return 1
fi
done
return 0
}
# since this script assumes the build is from full source, it nullifies
# variables likely to have been set by a "ws" script; nullification
# confines the search space for headers and libraries to the proto area
# built from this immediate source.
ENVLDLIBS1="-L$ROOT/lib -L$ROOT/usr/lib"
ENVCPPFLAGS1="-I$ROOT/usr/include"
export ENVLDLIBS1 ENVLDLIBS2
if [ "$SPARC_RM_PKGARCHIVE" ]; then
fi
#
# Juggle the logs and optionally send mail on completion.
#
fi
export LLOG
if [ -f $TMPDIR/wsdiff.results ]; then
fi
fi
#
# Now that we're about to send mail, it's time to check the noise
# file. In the event that an error occurs beyond this point, it will
# be recorded in the nightly.log file, but nowhere else. This would
# include only errors that cause the copying of the noise log to fail
# or the mail itself not to be sent.
#
exec >>$LOGFILE 2>&1
if [ -s $build_noise_file ]; then
echo "\n==== Nightly build noise ====\n" |
tee -a $LOGFILE >>$mail_msg_file
echo | tee -a $LOGFILE >>$mail_msg_file
fi
y)
;;
i)
;;
*)
;;
esac
export NIGHTLY_STATUS
echo "\n==== Running POST_NIGHTLY command:" \
$POST_NIGHTLY $state 2>&1 | tee -a $mail_msg_file >> $LOGFILE
fi
${MAILTO}
fi
fi
}
#
# Remove the locks and temporary files on any exit
#
set -- $newdirlist
while [ $# -gt 0 ]; do
shift; shift
done
}
build_ok=i
# this will trigger cleanup(), above.
exit 1
}
trap cleanup 0
#
# Generic lock file processing -- make sure that the lock file doesn't
# exist. If it does, it should name the build host and PID. If it
# doesn't, then make sure we can create it. Clean up locks that are
# known to be stale (assumes host name is unique among build systems
# for the workspace).
lockf=$1
lockvar=$2
if [ -f $lockf ]; then
else
# stale lock; clear it out and continue
fi
else
fi
fi
if [ -f $lockf ]; then
echo "Lock file is $lockf."
exit 1
fi
}
# Ensure no other instance of this script is running on this host.
# LOCKNAME can be set in <env_file>, and is by default, but is not
# required due to the use of $ATLOG below.
if [ -n "$LOCKNAME" ]; then
fi
#
# Create from one, two, or three other locks:
# - protects against multiple builds in same workspace
# - protects against multiple 'u' copy-backs
# - protects against multiple 'U' copy-backs
#
# Overriding ISUSER to 1 causes the lock to be created as root if the
# script is run as root. The default is to create it as $STAFFER.
if [ "$u_FLAG" = "y" ]; then
fi
if [ "$U_FLAG" = "y" ]; then
# NIGHTLY_PARENT_ROOT is written as root if script invoked as root.
fi
# Locks have been taken, so we're doing a build and we're committed to
# the directories we may have created so far.
#
# Create mail_msg_file
#
mail_msg_file="${TMPDIR}/mail_msg"
build_time_file="${TMPDIR}/build_time"
#
# Move old LOGFILE aside
# ATLOG directory already made by 'create_lock' above
#
if [ -f $LOGFILE ]; then
fi
#
# Build OsNet source
#
SECONDS=0
echo "\n==== Nightly $maketype build started: $START_DATE ====" \
# make sure we log only to the nightly build file
build_noise_file="${TMPDIR}/build_noise"
echo "\n==== list of environment variables ====\n" >> $LOGFILE
if [ "$P_FLAG" = "y" ]; then
fi
if [ "$T_FLAG" = "y" ]; then
fi
if is_source_build; then
echo "WARNING: the -S flags do not support incremental" \
i_FLAG=n
fi
if [ "$N_FLAG" = "n" ]; then
echo "WARNING: the -S flags do not support protocmp;" \
"protocmp disabled\n" | \
N_FLAG=y
fi
if [ "$l_FLAG" = "y" ]; then
echo "WARNING: the -S flags do not support lint;" \
l_FLAG=n
fi
if [ "$C_FLAG" = "y" ]; then
echo "WARNING: the -S flags do not support cstyle;" \
C_FLAG=n
fi
else
if [ "$N_FLAG" = "y" ]; then
if [ "$p_FLAG" = "y" ]; then
cat <<EOF | tee -a $mail_msg_file >> $LOGFILE
WARNING: the p option (create packages) is set, but so is the N option (do
not run protocmp); this is dangerous; you should unset the N option
EOF
else
cat <<EOF | tee -a $mail_msg_file >> $LOGFILE
Warning: the N option (do not run protocmp) is set; it probably shouldn't be
EOF
fi
fi
fi
echo "WARNING: Neither DEBUG nor non-DEBUG build requested, but the" \
fi
echo "WARNING: DEBUG build not requested, but lint will be with" \
"DEBUG enabled.\n" \
fi
if [ "$f_FLAG" = "y" ]; then
if [ "$i_FLAG" = "y" ]; then
echo "WARNING: the -f flag cannot be used during incremental" \
f_FLAG=n
fi
echo "WARNING: the -f flag requires -l and -p; ignoring -f\n" | \
f_FLAG=n
fi
fi
echo "WARNING: -w specified, but no pre-existing proto area found;" \
w_FLAG=n
fi
if [ "$t_FLAG" = "n" ]; then
#
# We're not doing a tools build, so make sure elfsign(1) is
# new enough to safely sign non-crypto binaries. We test
# debugging output from elfsign to detect the old version.
#
-e /usr/lib/security/pkcs11_softtoken.so.1 2>&1 \
if [ -z "$newelfsigntest" ]; then
"will only sign crypto modules\n" | \
export ELFSIGN_OBJECT=true
elif [ "$VERIFY_ELFSIGN" = "y" ]; then
echo "WARNING: VERIFY_ELFSIGN=y requires" \
"the -t flag; ignoring VERIFY_ELFSIGN\n" | \
fi
fi
# System
# nightly (will fail in year 2100 due to SCCS flaw)
# make
echo "number of concurrent jobs = $DMAKE_MAX_JOBS" |
#
# Report the compiler versions.
#
else
echo "\nUnable to find \"Makefile\" in $BRINGOVER_WS/usr/src or $SRC." |
exit 1
fi
( cd $srcroot
echo
#
# Put statefile somewhere we know we can write to rather than trip
# over a read-only $srcroot.
#
continue
fi
done
echo
if [ -f $TMPDIR/nocompiler ]; then
build_ok=n
echo "Aborting due to missing compiler." |
exit 1
fi
# as
# Check that we're running a capable link-editor
echo "The link-editor needs to be at version 422 or higher to build" | \
echo "the latest stuff, hope your build works." | \
fi
echo "\nBuild project: $build_project\nBuild taskid: $build_taskid" | \
# Save the current proto area if we're comparing against the last build
if [ -d "$ROOT.prev" ]; then
fi
fi
#
# Decide whether to clobber
#
cd $SRC
# remove old clobber file
# Remove all .make.state* files, just in case we are restarting
# the build after having interrupted a previous 'make clobber'.
echo "\n==== Make clobber ERRORS ====\n" >> $mail_msg_file
egrep -v "Ignoring unknown host" \
if [ "$t_FLAG" = "y" ]; then
cd ${TOOLS}
echo "\n==== Make tools clobber ERRORS ====\n" \
mkdir -p ${TOOLS_PROTO}
fi
# Get back to a clean workspace as much as possible to catch
# problems that only occur on fresh workspaces.
# Remove all .make.state* files, libraries, and .o's that may
# have been omitted from clobber. A couple of libraries are
# under SCCS, so leave them alone.
# We should probably blow away temporary directories too.
cd $SRC
-name '*.o' \) -print | \
else
fi
#
# Decide whether to bringover to the codemgr workspace
#
if [ "$n_FLAG" = "n" ]; then
# sleep on the parent workspace's lock
do
sleep 120
done
echo "\n==== BRINGOVER LOG ====\n" >> $mail_msg_file
-w $CODEMGR_WS $BRINGOVER_FILES < /dev/null 2>&1 ||
if [ -s $TMPDIR/bringovercheck.out ]; then
echo "\n==== POST-BRINGOVER CLEANUP NOISE ====\n"
fi
if [ -f $TMPDIR/bringover_failed ]; then
build_ok=n
exit 1
fi
#
# Possible transition from pre-split workspace to split
# workspace. See if the bringover changed anything.
#
else
echo "\n==== No bringover to $CODEMGR_WS ====\n" >> $LOGFILE
fi
#
# Build tools if requested
#
if [ "$t_FLAG" = "y" ]; then
export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
export RELEASE_BUILD ; RELEASE_BUILD=
unset EXTRA_OPTIONS
unset EXTRA_CFLAGS
fi
#
# copy ihv proto area in addition to the build itself
#
if [ "$X_FLAG" = "y" ]; then
fi
echo "\n==== NOT Building base OS-Net source ====\n" | \
else
fi
#
# For the "open" build, we don't mung any source files, so skip this
# step.
#
rm -f ${SCCSHELPER}
cat >${SCCSHELPER} <<EOF
#!/bin/ksh
cd \$1
cd ..
sccs get SCCS >/dev/null 2>&1
EOF
cd $SRC
chmod +x ${SCCSHELPER}
rm -f ${SCCSHELPER}
fi
if [ "$SD_FLAG" = "y" ]; then
fi
# EXPORT_SRC comes after CRYPT_SRC since a domestic build will need
fi
if [ "$SD_FLAG" = "y" ]; then
# drop the crypt files in place.
cd ${EXPORT_SRC}
echo "\nextracting crypt_files.cpio.Z onto export_source.\n" \
>> ${LOGFILE}
if [ "$?" = "0" ]; then
echo "\n==== DOMESTIC extraction succeeded ====\n" \
else
echo "\n==== DOMESTIC extraction failed ====\n" \
fi
fi
if [ "$SO_FLAG" = "y" ]; then
#
# Copy the open sources into their own tree, set up the closed
# binaries, and set up the environment.
#
# Try not to clobber any user-provided closed binaries.
echo "\n==== Copying skeleton closed binaries to $ON_CLOSED_BINS ====\n" | \
if [ $? -ne 0 ]; then
build_ok=n
echo "Aborting (couldn't create closed binaries)." |
fi
fi
if is_source_build && [ $build_ok = y ] ; then
# remove proto area here, since we don't clobber
if [ "$t_FLAG" = "y" ]; then
export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
export RELEASE_BUILD ; RELEASE_BUILD=
unset EXTRA_OPTIONS
unset EXTRA_CFLAGS
#
# SRC was set earlier to point to the source build
# source tree (e.g., $EXPORT_SRC).
#
fi
fi
fi
if [ "$build_ok" = "y" ]; then
>> $LOGFILE
>> $LOGFILE
if [ "$N_FLAG" != "y" ]; then
echo "\n==== Impact on packages ====\n" >> $mail_msg_file
# If there is a reference proto list, compare the build's proto
# list with the reference to see changes in proto areas.
# Use the current exception list.
fi
fi
if [ -f "$REF_PROTO_LIST" ]; then
# For builds that copy the IHV proto area (-X), add the
# IHV proto list to the reference list if the reference
# was built without -X.
#
# For builds that don't copy the IHV proto area, add the
# IHV proto list to the build's proto list if the
# reference was built with -X.
#
# Use the presence of the first file entry of the cached
# IHV proto list in the reference list to determine
# whether it was build with -X or not.
$IHV_REF_PROTO_LIST 2> /dev/null)
if [ $? = 0 -a -n "$grepfor" ]; then
if [ "$X_FLAG" = "y" ]; then
if [ ! "$?" = "0" ]; then
fi
else
if [ "$?" = "0" ]; then
fi
fi
fi
"Files in yesterday's proto area, but not today's:" \
"Files in today's proto area, but not yesterday's:" \
"Files that changed between yesterday and today:" \
${ELIST} \
-d $REF_PROTO_LIST \
fi
# Compare the build's proto list with current package
# definitions to audit the quality of package definitions
# and makefile install targets. Use the current exception list.
PKGDEFS_LIST=""
for d in $abssrcdirs; do
PKGDEFS_LIST="$PKGDEFS_LIST -d $d/pkgdefs"
fi
done
fi
"Files missing from the proto area:" \
"Files missing from packages:" \
"Inconsistencies between pkgdefs and proto area:" \
${ELIST} \
${PKGDEFS_LIST} \
fi
fi
fi
# Update parent proto area if necessary. This is done now
# so that the proto area has either DEBUG or non-DEBUG kernels.
# Note that this clears out the lock file, so we can dispense with
# the variable now.
echo "\n==== Copying proto area to $NIGHTLY_PARENT_ROOT ====\n" | \
# The rm -rf command below produces predictable errors if
# and that directory is accessed via NFS. This is because
# deleted-but-still-open files don't actually disappear as
# expected, but rather turn into .nfsXXXX junk files, leaving
# the directory non-empty. Since this is a not-unusual usage
# pattern, and we still want to catch other errors here, we
# take the unusal step of moving aside 'nightly' from that
# directory (if we're using it).
if [ "$mypath" = $0 ]; then
fi
fi
unset Ulockfile
cd $ROOT
fi
#
# do shared library interface verification
#
echo "\n==== Check versioning and ABI information ====\n" | \
if [ -d $SRC/interfaces.out ]; then
fi
# report any ERROR found in log file
if [ ! -d $SRC/interfaces.ref ] ; then
if [ -d $SRC/interfaces.out ]; then
fi
fi
echo "\n==== Diff versioning warnings (since last build) ====\n" | \
# Report any differences in WARNING messages between last
# and current build.
fi
fi
echo "\n==== Check ELF runtime attributes ====\n" | \
LDDUSAGE="^ldd: does not support -e"
LDDWRONG="wrong class"
CRLERROR="^crle:"
CRLECONF="^crle: configuration file:"
if [ -f $SRC/runtime.out ]; then
fi
# If we're doing a debug build the proto area will be left with
# debuggable objects, thus don't assert -s.
if [ "$D_FLAG" = "y" ]; then
rtime_sflag=""
else
rtime_sflag="-s"
fi
# Determine any processing errors that will affect the final output
# and display these first.
if [ $? -eq 0 ]; then
echo "WARNING: ldd(1) does not support -e. The version of ldd(1)" | \
echo "on your system is old - 4390308 (s81_30) is required.\n" | \
fi
if [ $? -eq 0 ]; then
echo "WARNING: wrong class message detected. ldd(1) was unable" | \
echo "to execute an object, thus it could not be checked fully." | \
echo "Perhaps a 64-bit object was encountered on a 32-bit system," | \
echo "or an i386 object was encountered on a sparc system?\n" | \
fi
if [ $? -eq 0 ]; then
echo "WARNING: creation of an alternative dependency cache failed." | \
echo "Dependencies will bind to the base system libraries.\n" | \
fi
# NEEDED= and RPATH= are informational; report anything else that we
# haven't already.
# probably should compare against a 'known ok runpaths' list
if [ ! -f $SRC/runtime.ref ]; then
fi
echo "\n==== Diff ELF runtime attributes (since last build) ====\n" \
fi
# DEBUG lint of kernel begins
if [ "$LINTDIRS" = "" ]; then
fi
set $LINTDIRS
while [ $# -gt 0 ]; do
done
else
fi
# "make check" begins
# remove old check.out
cd $SRC
echo "\n==== cstyle/hdrchk errors ====\n" >> $mail_msg_file
egrep -v "Ignoring unknown host" | \
else
fi
echo "\n==== Find core files ====\n" | \
echo "\n==== Diff unreferenced files (since last build) ====\n" \
fi
fi
fi
# Verify that the usual lists of files, such as exception lists,
# contain only valid references to files. If the build has failed,
# then don't check the proto area.
CHECK_PATHS=${CHECK_PATHS:-y}
if [ "$CHECK_PATHS" = y -a "$N_FLAG" != y ]; then
arg=-b
fi
echo "\n==== Impact on file permissions ====\n" \
#
#
`for d in $abssrcdirs; do
then
fi
fi
echo "\n==== Objects that differ since last build ====\n" | \
if [ "$t_FLAG" = "y" ]; then
else
fi
fi
echo "\n==== Total build time ====" | \
echo "\nreal ${hours}:${minutes}:${seconds}" | \
#
# Produce a master list of unreferenced files -- ideally, we'd
# generate the master just once after all of the nightlies
# have finished, but there's no simple way to know when that
# will be. Instead, we assume that we're the last nightly to
# finish and merge all of the unref-${MACH}.out files in
# finish, then this file will be the authoritative master
# list. Otherwise, another ${MACH}'s nightly will eventually
# overwrite ours with its own master, but in the meantime our
# temporary "master" will be no worse than any older master
# which was already on the parent.
#
shift
for unreffile; do
done
fi
#
# All done save for the sweeping up.
# (whichever exit we hit here will trigger the "cleanup" trap which
# optionally sends mail on completion).
#
if [ "$build_ok" = "y" ]; then
exit 0
fi
exit 1